// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/monitoring/v3/alert_service.proto
// Original file comments:
// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fmonitoring_2fv3_2falert_5fservice_2eproto__INCLUDED
#define GRPC_google_2fmonitoring_2fv3_2falert_5fservice_2eproto__INCLUDED

#include "google/monitoring/v3/alert_service.pb.h"

#include <functional>
#include <grpc/impl/codegen/port_platform.h>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace google {
namespace monitoring {
namespace v3 {

// The AlertPolicyService API is used to manage (list, create, delete,
// edit) alert policies in Stackdriver Monitoring. An alerting policy is
// a description of the conditions under which some aspect of your
// system is considered to be "unhealthy" and the ways to notify
// people or services about this state. In addition to using this API, alert
// policies can also be managed through
// [Stackdriver Monitoring](https://cloud.google.com/monitoring/docs/),
// which can be reached by clicking the "Monitoring" tab in
// [Cloud Console](https://console.cloud.google.com/).
class AlertPolicyService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.monitoring.v3.AlertPolicyService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the existing alerting policies for the workspace.
    virtual ::grpc::Status ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::google::monitoring::v3::ListAlertPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::ListAlertPoliciesResponse>> AsyncListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::ListAlertPoliciesResponse>>(AsyncListAlertPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::ListAlertPoliciesResponse>> PrepareAsyncListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::ListAlertPoliciesResponse>>(PrepareAsyncListAlertPoliciesRaw(context, request, cq));
    }
    // Gets a single alerting policy.
    virtual ::grpc::Status GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::google::monitoring::v3::AlertPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>> AsyncGetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>>(AsyncGetAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>> PrepareAsyncGetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>>(PrepareAsyncGetAlertPolicyRaw(context, request, cq));
    }
    // Creates a new alerting policy.
    virtual ::grpc::Status CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::google::monitoring::v3::AlertPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>> AsyncCreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>>(AsyncCreateAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>> PrepareAsyncCreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>>(PrepareAsyncCreateAlertPolicyRaw(context, request, cq));
    }
    // Deletes an alerting policy.
    virtual ::grpc::Status DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAlertPolicyRaw(context, request, cq));
    }
    // Updates an alerting policy. You can either replace the entire policy with
    // a new one or replace only certain fields in the current alerting policy by
    // specifying the fields to be updated via `updateMask`. Returns the
    // updated alerting policy.
    virtual ::grpc::Status UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::google::monitoring::v3::AlertPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>> AsyncUpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>>(AsyncUpdateAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>> PrepareAsyncUpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>>(PrepareAsyncUpdateAlertPolicyRaw(context, request, cq));
    }
    class experimental_async_interface {
     public:
      virtual ~experimental_async_interface() {}
      // Lists the existing alerting policies for the workspace.
      virtual void ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
      // Gets a single alerting policy.
      virtual void GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
      // Creates a new alerting policy.
      virtual void CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
      // Deletes an alerting policy.
      virtual void DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
      // Updates an alerting policy. You can either replace the entire policy with
      // a new one or replace only certain fields in the current alerting policy by
      // specifying the fields to be updated via `updateMask`. Returns the
      // updated alerting policy.
      virtual void UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
    };
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    typedef class experimental_async_interface async_interface;
    #endif
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    async_interface* async() { return experimental_async(); }
    #endif
    virtual class experimental_async_interface* experimental_async() { return nullptr; }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::ListAlertPoliciesResponse>* AsyncListAlertPoliciesRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::ListAlertPoliciesResponse>* PrepareAsyncListAlertPoliciesRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>* AsyncGetAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>* PrepareAsyncGetAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>* AsyncCreateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>* PrepareAsyncCreateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>* AsyncUpdateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::monitoring::v3::AlertPolicy>* PrepareAsyncUpdateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::google::monitoring::v3::ListAlertPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::ListAlertPoliciesResponse>> AsyncListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::ListAlertPoliciesResponse>>(AsyncListAlertPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::ListAlertPoliciesResponse>> PrepareAsyncListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::ListAlertPoliciesResponse>>(PrepareAsyncListAlertPoliciesRaw(context, request, cq));
    }
    ::grpc::Status GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::google::monitoring::v3::AlertPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>> AsyncGetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>>(AsyncGetAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>> PrepareAsyncGetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>>(PrepareAsyncGetAlertPolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::google::monitoring::v3::AlertPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>> AsyncCreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>>(AsyncCreateAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>> PrepareAsyncCreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>>(PrepareAsyncCreateAlertPolicyRaw(context, request, cq));
    }
    ::grpc::Status DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAlertPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::google::monitoring::v3::AlertPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>> AsyncUpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>>(AsyncUpdateAlertPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>> PrepareAsyncUpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>>(PrepareAsyncUpdateAlertPolicyRaw(context, request, cq));
    }
    class experimental_async final :
      public StubInterface::experimental_async_interface {
     public:
      void ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void ListAlertPolicies(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
      void GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void GetAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
      void CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void CreateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
      void DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void DeleteAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
      void UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void UpdateAlertPolicy(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
     private:
      friend class Stub;
      explicit experimental_async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class experimental_async_interface* experimental_async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class experimental_async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::ListAlertPoliciesResponse>* AsyncListAlertPoliciesRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::ListAlertPoliciesResponse>* PrepareAsyncListAlertPoliciesRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>* AsyncGetAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>* PrepareAsyncGetAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>* AsyncCreateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>* PrepareAsyncCreateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>* AsyncUpdateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::monitoring::v3::AlertPolicy>* PrepareAsyncUpdateAlertPolicyRaw(::grpc::ClientContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAlertPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAlertPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAlertPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAlertPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAlertPolicy_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the existing alerting policies for the workspace.
    virtual ::grpc::Status ListAlertPolicies(::grpc::ServerContext* context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response);
    // Gets a single alerting policy.
    virtual ::grpc::Status GetAlertPolicy(::grpc::ServerContext* context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response);
    // Creates a new alerting policy.
    virtual ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response);
    // Deletes an alerting policy.
    virtual ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response);
    // Updates an alerting policy. You can either replace the entire policy with
    // a new one or replace only certain fields in the current alerting policy by
    // specifying the fields to be updated via `updateMask`. Returns the
    // updated alerting policy.
    virtual ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAlertPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAlertPolicies() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAlertPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAlertPolicies(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAlertPolicies(::grpc::ServerContext* context, ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::monitoring::v3::ListAlertPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAlertPolicy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAlertPolicy(::grpc::ServerContext* context, ::google::monitoring::v3::GetAlertPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::monitoring::v3::AlertPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAlertPolicy() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAlertPolicy(::grpc::ServerContext* context, ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::monitoring::v3::AlertPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAlertPolicy() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAlertPolicy(::grpc::ServerContext* context, ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAlertPolicy() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAlertPolicy(::grpc::ServerContext* context, ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::monitoring::v3::AlertPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAlertPolicies<WithAsyncMethod_GetAlertPolicy<WithAsyncMethod_CreateAlertPolicy<WithAsyncMethod_DeleteAlertPolicy<WithAsyncMethod_UpdateAlertPolicy<Service > > > > > AsyncService;
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ListAlertPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ListAlertPolicies() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::ListAlertPoliciesRequest, ::google::monitoring::v3::ListAlertPoliciesResponse>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::google::monitoring::v3::ListAlertPoliciesRequest* request, ::google::monitoring::v3::ListAlertPoliciesResponse* response) { return this->ListAlertPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListAlertPolicies(
        ::grpc::experimental::MessageAllocator< ::google::monitoring::v3::ListAlertPoliciesRequest, ::google::monitoring::v3::ListAlertPoliciesResponse>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(0);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::ListAlertPoliciesRequest, ::google::monitoring::v3::ListAlertPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ListAlertPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAlertPolicies(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ListAlertPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ListAlertPolicies(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_GetAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_GetAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::GetAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::google::monitoring::v3::GetAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response) { return this->GetAlertPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetAlertPolicy(
        ::grpc::experimental::MessageAllocator< ::google::monitoring::v3::GetAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(1);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::GetAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_GetAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* GetAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* GetAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_CreateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_CreateAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::CreateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::google::monitoring::v3::CreateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response) { return this->CreateAlertPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAlertPolicy(
        ::grpc::experimental::MessageAllocator< ::google::monitoring::v3::CreateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(2);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::CreateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_CreateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* CreateAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* CreateAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_DeleteAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_DeleteAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::DeleteAlertPolicyRequest, ::google::protobuf::Empty>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::google::monitoring::v3::DeleteAlertPolicyRequest* request, ::google::protobuf::Empty* response) { return this->DeleteAlertPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAlertPolicy(
        ::grpc::experimental::MessageAllocator< ::google::monitoring::v3::DeleteAlertPolicyRequest, ::google::protobuf::Empty>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(3);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::DeleteAlertPolicyRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_DeleteAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* DeleteAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* DeleteAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_UpdateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_UpdateAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::UpdateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::google::monitoring::v3::UpdateAlertPolicyRequest* request, ::google::monitoring::v3::AlertPolicy* response) { return this->UpdateAlertPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAlertPolicy(
        ::grpc::experimental::MessageAllocator< ::google::monitoring::v3::UpdateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(4);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::monitoring::v3::UpdateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_UpdateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* UpdateAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* UpdateAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/)
    #endif
      { return nullptr; }
  };
  #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
  typedef ExperimentalWithCallbackMethod_ListAlertPolicies<ExperimentalWithCallbackMethod_GetAlertPolicy<ExperimentalWithCallbackMethod_CreateAlertPolicy<ExperimentalWithCallbackMethod_DeleteAlertPolicy<ExperimentalWithCallbackMethod_UpdateAlertPolicy<Service > > > > > CallbackService;
  #endif

  typedef ExperimentalWithCallbackMethod_ListAlertPolicies<ExperimentalWithCallbackMethod_GetAlertPolicy<ExperimentalWithCallbackMethod_CreateAlertPolicy<ExperimentalWithCallbackMethod_DeleteAlertPolicy<ExperimentalWithCallbackMethod_UpdateAlertPolicy<Service > > > > > ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAlertPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAlertPolicies() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAlertPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAlertPolicies(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAlertPolicy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAlertPolicy() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAlertPolicy() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAlertPolicy() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAlertPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAlertPolicies() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAlertPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAlertPolicies(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAlertPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAlertPolicy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAlertPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAlertPolicy() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAlertPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAlertPolicy() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAlertPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAlertPolicy() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAlertPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ListAlertPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ListAlertPolicies() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAlertPolicies(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_ListAlertPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAlertPolicies(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ListAlertPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ListAlertPolicies(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_GetAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_GetAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAlertPolicy(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_GetAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* GetAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* GetAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_CreateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_CreateAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAlertPolicy(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_CreateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* CreateAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* CreateAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_DeleteAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_DeleteAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAlertPolicy(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_DeleteAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* DeleteAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* DeleteAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_UpdateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_UpdateAlertPolicy() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAlertPolicy(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_UpdateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* UpdateAlertPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* UpdateAlertPolicy(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAlertPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAlertPolicies() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::monitoring::v3::ListAlertPoliciesRequest, ::google::monitoring::v3::ListAlertPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::monitoring::v3::ListAlertPoliciesRequest, ::google::monitoring::v3::ListAlertPoliciesResponse>* streamer) {
                       return this->StreamedListAlertPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAlertPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAlertPolicies(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::ListAlertPoliciesRequest* /*request*/, ::google::monitoring::v3::ListAlertPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAlertPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::monitoring::v3::ListAlertPoliciesRequest,::google::monitoring::v3::ListAlertPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAlertPolicy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::monitoring::v3::GetAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::monitoring::v3::GetAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>* streamer) {
                       return this->StreamedGetAlertPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::GetAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAlertPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::monitoring::v3::GetAlertPolicyRequest,::google::monitoring::v3::AlertPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAlertPolicy() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::monitoring::v3::CreateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::monitoring::v3::CreateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>* streamer) {
                       return this->StreamedCreateAlertPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::CreateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAlertPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::monitoring::v3::CreateAlertPolicyRequest,::google::monitoring::v3::AlertPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAlertPolicy() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::monitoring::v3::DeleteAlertPolicyRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::monitoring::v3::DeleteAlertPolicyRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteAlertPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::DeleteAlertPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAlertPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::monitoring::v3::DeleteAlertPolicyRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAlertPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAlertPolicy() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::monitoring::v3::UpdateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::monitoring::v3::UpdateAlertPolicyRequest, ::google::monitoring::v3::AlertPolicy>* streamer) {
                       return this->StreamedUpdateAlertPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAlertPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAlertPolicy(::grpc::ServerContext* /*context*/, const ::google::monitoring::v3::UpdateAlertPolicyRequest* /*request*/, ::google::monitoring::v3::AlertPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAlertPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::monitoring::v3::UpdateAlertPolicyRequest,::google::monitoring::v3::AlertPolicy>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAlertPolicies<WithStreamedUnaryMethod_GetAlertPolicy<WithStreamedUnaryMethod_CreateAlertPolicy<WithStreamedUnaryMethod_DeleteAlertPolicy<WithStreamedUnaryMethod_UpdateAlertPolicy<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAlertPolicies<WithStreamedUnaryMethod_GetAlertPolicy<WithStreamedUnaryMethod_CreateAlertPolicy<WithStreamedUnaryMethod_DeleteAlertPolicy<WithStreamedUnaryMethod_UpdateAlertPolicy<Service > > > > > StreamedService;
};

}  // namespace v3
}  // namespace monitoring
}  // namespace google


#endif  // GRPC_google_2fmonitoring_2fv3_2falert_5fservice_2eproto__INCLUDED
